// Create some generic timing functions so that we can easily swap
// between choices.

#include <stdlib.h>
#include "timing418.h"

#ifdef GetTimeOfDay

void timestamp(timer_418 *t) {
  gettimeofday(t, NULL);
}

double elapsed_seconds(timer_418 t1, timer_418 t0) {
  return (t1.tv_sec - t0.tv_sec) + 1e-6 * (t1.tv_usec - t0.tv_usec);
}

#endif

#ifdef RUsage

void timestamp(timer_418 *t) {
  getrusage(RUSAGE_SELF, t);
}

double elapsed_seconds(timer_418 t1, timer_418 t0) {
  return ((t1.ru_utime.tv_sec - t0.ru_utime.tv_sec)
	  + 1e-6 * (t1.ru_utime.tv_usec - t0.ru_utime.tv_usec));
}

#endif
